before_script:
 - apt-get update -qq
 - apt-get install -y -qq flex bison libglib2.0-dev libpixman-1-dev genisoimage

build-system1:
 script:
 - apt-get install -y -qq libgtk-3-dev libvte-dev nettle-dev libcacard-dev
      libusb-dev libvde-dev libspice-protocol-dev libgl1-mesa-dev libvdeplug-dev
 - ./configure --enable-werror --target-list="aarch64-softmmu alpha-softmmu
      cris-softmmu hppa-softmmu lm32-softmmu moxie-softmmu microblazeel-softmmu
      mips64el-softmmu m68k-softmmu ppc-softmmu riscv64-softmmu sparc-softmmu"
 - make -j2
 - make -j2 check

build-system2:
 script:
 - apt-get install -y -qq libsdl2-dev libgcrypt-dev libbrlapi-dev libaio-dev
      libfdt-dev liblzo2-dev librdmacm-dev libibverbs-dev libibumad-dev
 - ./configure --enable-werror --target-list="tricore-softmmu unicore32-softmmu
      microblaze-softmmu mips-softmmu riscv32-softmmu s390x-softmmu sh4-softmmu
      sparc64-softmmu x86_64-softmmu xtensa-softmmu nios2-softmmu or1k-softmmu"
 - make -j2
 - make -j2 check

build-disabled:
 script:
 - ./configure --enable-werror --disable-rdma --disable-slirp --disable-curl
      --disable-capstone --disable-live-block-migration --disable-glusterfs
      --disable-replication --disable-coroutine-pool --disable-smartcard
      --disable-guest-agent --disable-curses --disable-libxml2 --disable-tpm
      --disable-qom-cast-debug --disable-spice --disable-vhost-vsock
      --disable-vhost-net --disable-vhost-crypto --disable-vhost-user
      --target-list="i386-softmmu ppc64-softmmu mips64-softmmu i386-linux-user"
 - make -j2
 - make -j2 check-qtest SPEED=slow

build-tcg-disabled:
 script:
 - apt-get install -y -qq clang libgtk-3-dev libbluetooth-dev libusb-dev
 - ./configure --cc=clang --enable-werror --disable-tcg --audio-drv-list=""
 - make -j2
 - make check-unit
 - make check-qapi-schema
 - cd tests/qemu-iotests/
 - ./check -raw 001 002 003 004 005 008 009 010 011 012 021 025 032 033 048
            052 063 077 086 101 104 106 113 147 148 150 151 152 157 159 160
            163 170 171 183 184 192 194 197 205 208 215 221 222 226 227 236
 - ./check -qcow2 028 040 051 056 057 058 065 067 068 082 085 091 095 096 102
            122 124 127 129 132 139 142 144 145 147 151 152 155 157 165 194
            196 197 200 202 203 205 208 209 215 216 218 222 227 234 246 247
            248 250 254 255 256

build-user:
 script:
 - ./configure --enable-werror --disable-system --disable-guest-agent
               --disable-capstone --disable-slirp --disable-fdt
 - make -j2
 - make run-tcg-tests-i386-linux-user run-tcg-tests-x86_64-linux-user

build-clang:
 script:
 - apt-get install -y -qq clang libsdl2-dev libattr1-dev libcap-ng-dev
      xfslibs-dev libiscsi-dev libnfs-dev libseccomp-dev gnutls-dev librbd-dev
 - ./configure --cc=clang --cxx=clang++ --enable-werror
      --target-list="alpha-softmmu arm-softmmu m68k-softmmu mips64-softmmu
                     ppc-softmmu s390x-softmmu x86_64-softmmu arm-linux-user"
 - make -j2
 - make -j2 check

build-tci:
 script:
 - TARGETS="aarch64 alpha arm hppa m68k microblaze moxie ppc64 s390x x86_64"
 - ./configure --enable-tcg-interpreter
      --target-list="$(for tg in $TARGETS; do echo -n ${tg}'-softmmu '; done)"
 - make -j2
 - make tests/boot-serial-test tests/cdrom-test tests/pxe-test
 - for tg in $TARGETS ; do
     export QTEST_QEMU_BINARY="${tg}-softmmu/qemu-system-${tg}" ;
     ./tests/boot-serial-test || exit 1 ;
     ./tests/cdrom-test || exit 1 ;
   done
 - QTEST_QEMU_BINARY="x86_64-softmmu/qemu-system-x86_64" ./tests/pxe-test
 - QTEST_QEMU_BINARY="s390x-softmmu/qemu-system-s390x" ./tests/pxe-test -m slow
